<?php

namespace Teknisa\EST\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error; 


class LocalestoqueForGer03700 extends \Teknisa\EST\Controllers\TeknisaCrud {
	protected $dataSourceName = 'localestoque_forGer03700';
	protected $parameterBagColumns = array('CDFILIAL', 'CDALMOXARIFE', 'CDLOCALESTOQ');
	protected $Ger03700Service;

	public function __construct($crudService, $parameterBag, $Ger03700Service) {
		parent::__construct($crudService, $parameterBag);
		$this->Ger03700Service = $Ger03700Service;
	}
	
	 //
	public function find(DTO\Request\Filter $request, DTO\Response $response) {
		parent::find($request, $response);
	}

	public function delete(DTO\Request $request, DTO\Response $response){
		$row = $request->getRow();

		try {
			$this->Ger03700Service->checaLocalizacaoPadrao($row['CDFILIAL'], $row['CDLOCALESTOQ']);
			parent::delete($request, $response);
		} catch	(\Exception $e){
			if(strpos($e->getMessage(), 'ORA-02292') === false){
				$str = $e->getMessage();
			} else {
				$str = "Exclusão bloqueada! Existem restrições na base de dados que impedem a exclusão da localização.";
			}
			$response->setError(new Error($str, 500));
		}
	}
}
