<?php

namespace Geral\Logic\PropostaComercial;

use Faturamento\Entities\Sistproplinp;
use Setforms2\Runtime\Framework;
use Geral\Entities\Sistema;

class SistemaPropostaComercial 
{
    public static function insertOrDeleteSistema($arrayInsert, $nrorg, $idInsertDelete = null)
    {
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        try{
            $sistproplinp = Sistproplinp::findOneByNrproposfasAndNrverpropfasAndCdlinppropAndCdsistemaAndNrorg($arrayInsert['NRPROPOSFAS'], $arrayInsert['NRVERPROPFAS'], 
                                                                                                               $arrayInsert['CDLINPPROP'], $arrayInsert['CDSISTEMA'], $nrorg);
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $dtinclusao = \Geral\Util\DateUtil::getDataAtual();
            
            if ($arrayInsert['IDMARCADO'] == 'S' && $idInsertDelete == 'INS' && !is_object($sistproplinp)) {
                $sistproplinp = new \Faturamento\Entities\Sistproplinp();
                $sistproplinp->setNrproposfas($arrayInsert['NRPROPOSFAS']);
                $sistproplinp->setNrverpropfas($arrayInsert['NRVERPROPFAS']);
                $sistproplinp->setCdlinpprop($arrayInsert['CDLINPPROP']);
                $sistproplinp->setCdsistema($arrayInsert['CDSISTEMA']);
                $sistproplinp->setDtinclusao($dtinclusao);
                $sistproplinp->setNrorg($nrorg);
                $sistproplinp->persist();
                $connection->flush();
            } elseif (is_object($sistproplinp) && $idInsertDelete == 'DEL') {
                $sistproplinp->delete();
                $connection->flush();
            }

            $db->getConn()->commit();

        }catch(\Exception $e){
            $db->getConn()->rollback();
            throw $e;
        }
    }
        
    public static function montaStrCdSistemas($arraySistemas, $sistemas)
    {
        $strSistemas = '';
        
        foreach($arraySistemas as $sistema) {
            $strSistemas .= '|'.$sistema['CDSISTEMA'];
        }
        
        if($sistemas) {
            foreach($sistemas as $sistema) {
                $strSistemas .= '|'.$sistema->getCdsistema();
            }
        }
        
        return $strSistemas;
    }
    
    public static function getProdConflitantes($listaSistemas)
    {
        $proComerciConflitantes = Sistema::getRepository()->getProdutosComerConflitantes($listaSistemas);
        $strReturnProdutos      = '';
        
        if(count($proComerciConflitantes) > 0) {
            foreach($proComerciConflitantes as $produto) {
                $strReturnProdutos .= $produto['NMPROCOMERCI'].' X '.$produto['NMPROCOMERELAC'].';<br/>';
            }            
        }
        
        return rtrim($strReturnProdutos, ';<br/>');
    }
    
    public static function retornaSistemasLinhaProduto($nrProposta, $nrVersao, $cdLinpProp, $nrOrg)
    {
        $sistemasLP = Sistproplinp::findByNrproposfasAndNrverpropfasAndCdlinppropAndNrorg($nrProposta, $nrVersao, $cdLinpProp, $nrOrg);
        
        return $sistemasLP;
    }
    
    public static function retornaDataSetSistemas()
    {
        $dataset     = Framework::getInstance()->getDataset();
        $arrayInsert = array();
        $arrayDelete = array();

        foreach ($dataset as $data) {
            if($data['IDMARCADO'] == 'S') {
                $arrayInsert[] = $data;
            } else {
                $arrayDelete[] = $data;
            }
        }
        
        $arrayRetorno['INSERT'] = $arrayInsert;
        $arrayRetorno['DELETE'] = $arrayDelete;
        
        return $arrayRetorno;
    }

    public static function getCdSistemasOrd($nrProposta, $nrVersao, $cdLinhaProduto, $nrOrg)
    {
        $cdSistemas = '';

        //Sistemas já inclusos, se houverem.
        $sistemas = self::retornaSistemasLinhaProduto($nrProposta, $nrVersao, $cdLinhaProduto, $nrOrg);

        //Sistemas a serem incluídos no momento.
        $dataSet = self::retornaDataSetSistemas();
        $dataIns = $dataSet['INSERT'];
        $dataDel = $dataSet['DELETE'];

        foreach ($sistemas as $sistema) {
            $cdSistema = $sistema->getCdsistema();
            $aux = true;

            //Verifica se o sistema que está inserido não consta nos que serão deletados.
            foreach ($dataDel as $dataD) {
                if($cdSistema == $dataD['CDSISTEMA']) {
                    $aux = false;
                    break;
                }
            }

            if($aux) {
                $cdSistemas .= $sistema->getCdsistema() . ' ';
            }
        }

        foreach($dataIns as $dataI) {
            $cdSistemas .= $dataI['CDSISTEMA'].' ';
        }

        $cdSistemas = rtrim($cdSistemas);

        return $cdSistemas;
    }
}